unit hiGL_FBO;

interface

uses kol,Share,Debug,OpenGL,OpenGL_Ex;

const
   glLinear = GL_LINEAR;
   glNearest = GL_NEAREST;

type
   THIGL_FBO = class(TDebug)

   private
   framebuffer: Cardinal;
   renderbuffer: Cardinal;
   texture: Cardinal;
   TEX_WIDTH :integer;
   TEX_HEIGHT:integer;
   size:integer;
   EXT_framebuffer:boolean;

   public
   _prop_TexFilter:cardinal;
   _prop_Anisotropy:integer;
   _prop_SizeTexture:integer;
   _prop_Color_Main:TColor;
   _prop_Color_FBO:TColor;

   _data_Anisotropy:THI_Event;
   _data_SizeTexture:THI_Event;

   _event_onInitFBO:THI_Event;
   _event_onDrawFBO:THI_Event;
   _event_onDraw:THI_Event;

procedure _work_InitFBO(var _Data:TData; Index:word);
procedure _work_DrawFBO(var _Data:TData; Index:word);

end;


implementation

procedure THIGL_FBO._work_InitFBO;

var
   n:   integer;
   tex: integer;
begin
   if ReadAndCheck_EXTframebuffer then
   EXT_framebuffer:= true
   else begin
      EXT_framebuffer := false;
      exit;
   end;
   glEnable(GL_TEXTURE_2D);
   //   .
   glGenFramebuffersEXT(1, @framebuffer);
   glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, framebuffer);
   //  .
   glGenTextures(1, @texture);
   glBindTexture(GL_TEXTURE_2D, texture);
   //    .
   size := ReadInteger(_Data, _data_SizeTexture,_prop_SizeTexture);
   n := ReadInteger(_Data, _data_Anisotropy,_prop_Anisotropy);
   TEX_WIDTH := size;
   TEX_HEIGHT := size;
   if n > 0 then glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAX_ANISOTROPY_EXT,n);
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, TEX_WIDTH, TEX_HEIGHT, 0, GL_RGB, GL_UNSIGNED_BYTE, 0);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,_prop_TexFilter);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,_prop_TexFilter);
   //   .
   glGenRenderbuffersEXT(1, @renderbuffer);
   glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, renderbuffer);
   glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT24_ARB, TEX_WIDTH, TEX_HEIGHT);
   //     ,    -   .
   glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
   GL_TEXTURE_2D, texture, 0);
   glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
   GL_RENDERBUFFER_EXT, renderbuffer);
   tex := texture;
   _hi_onEvent(_event_onInitFBO,tex);
end;

procedure THIGL_FBO._work_DrawFBO;

begin
   //   
   if EXT_framebuffer then
   else
   exit;
   glBindTexture(GL_TEXTURE_2D, 0);
   glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, framebuffer);
   glPushAttrib(GL_VIEWPORT_BIT);
   glViewport(0, 0, TEX_WIDTH, TEX_HEIGHT);
   with TRGB(_prop_Color_FBO) do
   glClearColor (r/255, g/255, b/255, 1.0);
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
   glPushMatrix;
   glLoadIdentity;
   glTranslatef(0,0,-8);
   _hi_onEvent(_event_onDrawFBO);
   glPopMatrix;
   glPopAttrib;
   glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
   with TRGB(_prop_Color_Main) do
   glClearColor (r/255, g/255, b/255, 0.0);
   glBindTexture(GL_TEXTURE_2D, texture);
   _hi_onEvent(_event_onDraw);
   glBindTexture(GL_TEXTURE_2D, 0);
end;

end.
